#!/usr/local/share/bin/perl -w -I/usr/local/web/docs/nmap-web/include
#
# ^^^ Update path-to-perl and include directory above ^^^


#-------------- Should be fairly boilerplate from here on out --------------
# nmap-web - a quick-n-dirty Web interface to nmap
# Copyright 2000  by Alek Komarnitsky, 
#     alek@komar.org, http://www.komar.org/komar/alek/
# See LICENSE for conditions of use. 

$version="1.5 (07/14/00)";

# Snarf in various code fragments ...
use nmap_web_local;
use nmap_web_local_ports;
use nmap_web_ports_parse;
use nmap_web_web_routines;
require 5.004;
$| = 1;           # Buffer out

# See if we are running in a command line or as a CGI
$html = 1 if ((defined($ENV{GATEWAY_INTERFACE})) &&  (length($ENV{GATEWAY_INTERFACE})));
&ReadParse;
if ( $html ) { 
   print "Content-type: text/html\n\n\n" ;
   print "<html>\n";
   print "<head>\n";
   print "<META NAME=\"CONTACT\" CONTENT=\"Komarnitsky, Alek O\">\n";
   print "<META NAME=\"SENSITIVITY\" CONTENT=\"UNRESTRICTED\">\n";
   print "</head>\n";
   &check_if_ip_ok_to_run();
   $thisURL = get_env_variable("^SCRIPT_NAME");
   $counter1 = &Get_Accumulator($count_file1) if ((defined($count_file1)) && (-r $count_file1));
   $counter2 = &Get_Accumulator($count_file2) if ((defined($count_file2)) && (-r $count_file2));
   $counter3 = &Get_Accumulator($count_file3) if ((defined($count_file3)) && (-r $count_file3));
   $tempvar = "$counter1-$counter2-$counter3" if (defined($counter1) && defined($counter2) && defined($counter3)); 

} else {
   print "Running from the CLI on ";
   system ("date"); 
}

if ( defined($in{'show_top_frame'}) ) {
   print "<form method=\"post\" action=\"$thisURL\" target=\"middle\">\n";
   print "<input type=\"hidden\" name=\"do_nmap\" value=\"true\">\n";
   print "Select port(s) to check: &nbsp &nbsp ";
   print "<select name=\"port_selection\">";
   foreach $_ (sort keys %ports) {    
      print "<option value=$_>$names{$_}</option>\n";
   }
   print "</select>\n";
   print " &nbsp &nbsp &nbsp &nbsp &nbsp &nbsp &nbsp &nbsp &nbsp &nbsp &nbsp &nbsp &nbsp &nbsp &nbsp<input type=\"submit\" name=\"PORT_INFO\" value=\"Port Numbers\"><br>\n";
   print "<input type=\"checkbox\" checked=\"true\" name=\"show_not_up\">";
   print "Show machines that do not appear to be up<br>\n";
   print "<input type=\"checkbox\" checked=\"true\" name=\"show_no_ports\">";
   print "Show machines that don't answer at any of the selected ports<br>\n";
   print "<input type=\"checkbox\" name=\"get_port_data\">";
   print "Get program/version info running on an INDIVIDUAL port selected<br>\n";
   print "<br>Select one of these groupings: ";
   print "<select name=\"grouping\">";
   foreach (@select_options) { 
      print "<option>$_\n" ;
   }
   print "</select> &nbsp &nbsp &nbsp &nbsp ";
   print "*OR* enter a space-separated list to scan: <input type=\"input\" size=\"9\" name=\"keyword\" >";
   print "<p>\n"; 
   print "<strong><input type=\"submit\" value=\"Start the Scan\"></strong>";
   print " &nbsp &nbsp &nbsp &nbsp &nbsp &nbsp &nbsp &nbsp &nbsp &nbsp &nbsp &nbsp &nbsp &nbsp &nbsp &nbsp &nbsp";
   print " &nbsp &nbsp &nbsp &nbsp &nbsp &nbsp &nbsp &nbsp &nbsp &nbsp &nbsp &nbsp &nbsp &nbsp &nbsp<input type=\"submit\" name=\"Help\" value=\"Help/Information/README\"><br>\n";
   print "</form>";
} elsif ( defined($in{'show_middle_frame'}) ) {
   print "A quick-n-dirty way to see which machines are running Web Servers and other services<br>";
   print "Questions/comments/suggestions to <a href=\"mailto:$author\">$author</a> - $version";
   print "($tempvar)" if (defined($tempvar));
   print "<br>\n";
} elsif ( defined($in{'Help'}) ) {
   system("cat $help_file");
} elsif ( defined($in{'PORT_INFO'}) ) {
   print "<pre>";
   foreach $_ (sort keys %ports) {    
      print "$names{$_}:<strong> expected=";
      if ( defined($expec{$_})) {
         print $expec{$_};
      } else {
         print "N/A";
      }
      print "</strong>    $ports{$_}\n";
   }
} elsif ( defined($in{'do_nmap'}) ) {
   print "<pre><p>" if ($html);
   if ((! $html) && ( defined($in{'CLI_ports'}))) {
      $nmap_ports = $in{'CLI_ports'};
   } elsif ( defined($ports{$in{'port_selection'}})) {
      $nmap_ports = $ports{$in{'port_selection'}};
   } else {
      print "do not know what to do with $in{'port_selection'} - exiting\n";
      print "</html>";
      exit(2);
   }
   if ( defined($in{'get_port_data'})) {
      if ( ! ($nmap_ports =~ /^\d+$/) ) {
         print "You requested program/version info on $nmap_ports\n\n\n";
         print "<strong>You can not get program/version info if more than one port selected<p>";
         print "</html>";
         exit(); 
      }
   }
   $counter1 = &Increment_Accumulator($count_file1,1) if ((defined($count_file1)) && ( -w $count_file1));
   $hosts_sel = "NONE" ; 
   if ((defined($in{'grouping'})) && ( $in{'grouping'} ne "NONE")) {
      $hosts_sel = $in{'grouping'}; 
   }
   if ((defined($in{'keyword'})) && ( $in{'keyword'} !~ /^\s*$/)) {
      $hosts_sel = $in{'keyword'};
      if ( $hosts_sel =~ /-ports \d+/ ) {
         $nmap_ports = $hosts_sel;
         $nmap_ports =~ s/^.*-ports (\S+)\s+.*$/$1/;
         $hosts_sel =~ s/^.*-ports \S+\s+(.*)$/$1/;
      }
   }
   if ($hosts_sel eq "NONE") {
      print "nothing entered ...";
      print "</html>";
      exit(2); 
   }
   @HOSTS = split(/\s+/,$hosts_sel);
   foreach (@HOSTS) {
      chomp(); 
      if (( /^\w[\w\,\.\-]*$/ ) && ( ! (/\-[\/\.\,\*\d]+\-/ ))) {
         # Looks like we got a "real" host/netgroups name
      } else {
         print "nmap-web does not allow funky wildcards ... sorry ...";
         print "</html>";
         exit(2);
      }
   }
   if ( defined($in{'get_port_data'})) {
      $_ = "$root_dir/include/query_port/$nmap_ports";
      if ( -r "$_" ) {
         require "$_";
      } else {
         print "There is no code to query for additional information on port $nmap_ports<p>\n";
         print "contact $author if you want to submit some code to handle this<p>";
         print "</html>";
         exit(2);
      }
   }
   if ( defined($getnetgroup_exec)) {
      @HOSTS = `$getnetgroup_exec $hosts_sel $getnetgroup_ignore | sort -u 2>&1` ;
   } else {
      @HOSTS = split(/\s+/,$hosts_sel);
   }
   $hosts_sel = "$hosts_sel $getnetgroup_ignore" if (defined($getnetgroup_ignore)); 
   print "There are " , $#HOSTS + 1 , " machines in $hosts_sel  - scanning ports $nmap_ports ...\n\n"; 
   $hosts_all_string = ""; 
   foreach (@HOSTS) {
      chomp(); 
      $hosts_all_string .= " $_";
   }
   print "<strong>" if ($html); 
   if ( $nmap_ports eq "0") {
      printf "%-50s%s" , "Hostname/IP address" , "   Ping Status\n";
   } elsif ( defined($in{'get_port_data'})) {
      if ( $nmap_ports eq "13") {
         printf "%-50s%s" , "Hostname/IP address" , "   Delta   Remote Date\n";
      } elsif (( $nmap_ports eq "80") && ( defined($in{'get_port_data'}))) {
         printf "%-50s%s" , "Hostname/IP address" , "   Web Server Type/Version\n";
      } else {
         printf "%-50s%s" , "Hostname/IP address" , "   Version\n";
      }
   } else {
      printf "%-50s%s" , "Hostname/IP address" , "   Ports that are Open from $nmap_ports \n";
   }
   print "</strong>" if ($html);
   &log_actions(); 
   if ( $nmap_ports eq "0" ) {
      open(NMAP_OUT,"$nmap_exec $nmap_ping_options $hosts_all_string 2>&1 |");
   } else {
      open(NMAP_OUT,"$nmap_exec $nmap_options -p $nmap_ports $hosts_all_string 2>&1 |");
   }
   $how_many_web_servers = 0; 
   while (<NMAP_OUT>) { 
      chomp();
      $line = $_;
      if ( /Nmap run completed/ ) { 
         print "\n\n$how_many_web_servers machines found answering the above ports\n$_ END\n"; 
      } elsif (( /^#/ ) || ( /^$/ ) || ( /^Starting nmap/ )) { 
         # Ignore all of these ...
      } elsif ( /Failed to resolve given/ ) { 
         $host = $line;
         $host =~ s/Note that you can.*$//;
         $host =~ s/Failed to resolve given hostname\/IP: //;
         $host =~ s/\.\s*$//;
         printf "%-50s%s" , "$host:" , "   UNRESOLVABLE\n";
      } elsif (/^Host: / ) {
         if ( $nmap_ports eq "0") {
            ($host,$_) = split(/\t/,$line);
            $host =~ s/Host: //;
            $host =~ s/\(\)/\(UNRESOLVEABLE\)/;
            if ( /Status: Up/ ) {
               printf "%-50s%s" , "$host:" , "   PINGABLE\n";
               $how_many_web_servers++;
            } else {
               if (( defined($in{'show_not_up'})) && ($in{'show_no_ports'} ne "true")) {
                  printf "%-50s%s" , "$host:" , "   NOT Pingable\n";
               }
            }
         } else {
            ($host,$open,$_) = split(/\t/,$line);
            $host =~ s/Host: //;
            $host =~ s/\(\)/\(UNRESOLVEABLE\)/;
            if ( $open =~ /Status: Up/ ) {
               if (( defined($in{'show_no_ports'})) && ($in{'show_no_ports'} eq "on")) {
                  printf "%-50s%s" , "$host:" , "   Nothing Open\n";
               }
            } elsif ( $open =~ /Status: Down/ ) {
               if (( defined($in{'show_not_up'})) && ($in{'show_no_ports'} ne "true")) {
                  printf "%-50s%s" , "$host:" , "   Not Pingable\n";
               }
            } else {
               printf "%-50s" , "$host:";
               $how_many_web_servers++;
               @ports_open = split(/\s+/,$open);
               @ports_all = (); 
               foreach $_ (@ports_open) {
                  next if ( /^Ports/ );
                  ($portnum,$_) = split(/\//,$_);
                  $portnum =~ s/ *//;
                  push(@ports_all,$portnum);
               }
               if ( defined($in{'get_port_data'})) {
                  $host =~ s/ \(.*$//; 
                  $_ = &get_port_data($host,$nmap_ports,$in{'port_selection'});
                  print "   $_";
               } else {
                  foreach $_ (@ports_all) { print "   $_"; } 
               }
               print "\n"; 
            }
         }
      } elsif ( /Skipping host/ ) { 
         print "STRANGE SKIPPING CONDITION WITH $_ END\n";
         print "Pls let $author know you saw this ... <p>";
         next;
         s/Skipping host //;
         $host = $_ ;
         $host =~ s/^(.*)\(\d+.*$/$1/ ;
         $host = "UNRESOLVEABLE" if ( $host =~ /^ *$/);
         $ip = $_ ;
         $ip =~ s/^.*\(([\d\.]+)\).*$/$1/ ;
         printf "%-50s%s" , "host $host (ip is $ip):" , "   Timed Out";;
      } elsif ( /due to host timeout/ ) {
         print "STRANGE HOST TIMEOUT CONDITION WITH $_ END<p>\n";
         print "Pls let $author know you saw this ... <p>";
         next;
         s/Interesting ports on //;
         $host = $_ ;
         $host =~ s/^(.*)\(\d+.*$/$1/ ;
         $host = "UNRESOLVEABLE" if ( $host =~ /^ *$/);
         $ip = $_ ;
         $ip =~ s/^.*\(([\d\.]+)\).*$/$1/ ;
         printf "%-50s%s" , "host $host (ip is $ip):" , "   Timed Out too";;
      } else {
         print "should NOT have gotten here with $_ END<p>\n";
         print "Pls let $author know you saw this ... <p>";
      }
   }
   close(NMAP_OUT);
   print "<p><br><p>" if ($html);
   $counter2 = &Increment_Accumulator($count_file2,$how_many_web_servers) if ((defined($count_file2)) && (-w $count_file2));
   $counter3 = &Increment_Accumulator($count_file3,$#HOSTS +1) if ((defined($count_file3)) && (-w $count_file3));
} else {
   print "Should NOT get here - some sort of error with frame select (?)...<p>";
   print "Pls let $author know you saw this ... <p>";
}
print "\n";
print "</html>" if ($html);
exit(); 


sub log_actions {
   my ($browserhost,$ip,@iplist);
   $_ = get_env_variable("^REMOTE_ADDR");
   if ( $_ ne "" ) {
      s/^.*=//s;
      @iplist = split(/\./,$_);
      $ip = pack('C4',@iplist);
      $browserhost = gethostbyaddr($ip,AF_INET);
   }
   $browserhost = get_env_variable("^REMOTE_ADDR") if ( $browserhost eq "");
   $_ = "JUST_OPEN";
   $_ = "GET_RESULTS" if (defined($in{'get_port_data'})) ;
   system ("echo \"`date`	$browserhost	-p $nmap_ports	$_	$hosts_sel\" >> $log_file") if (defined($log_file)); 
}


sub check_if_ip_ok_to_run {
   $_ = get_env_variable("^REMOTE_ADDR");
   if ( ! /$ips_who_can_use/ ) { 
      print "You are not allowed to use this ... contact $author for more info<p>";
      print "</html>";
      exit(2);
   }
}
