# HTML parsing ...
sub ReadParse {
   if (@_) { local (*in) = @_; }
   local ($i, $loc, $key, $val);
   # Read in text
   if ($ENV{'REQUEST_METHOD'} eq "GET") {
      $in = $ENV{'QUERY_STRING'};
   } elsif ($ENV{'REQUEST_METHOD'} eq "POST") {
      for ($i = 0; $i < $ENV{'CONTENT_LENGTH'}; $i++) {
         $in .= getc;  }
   }
   @in = split(/&/,$in);
   foreach $i (0 .. $#in) {
      $_ = $in[$i];
      $in[$i] = &sanitize($_);
      # Convert plus's to spaces
      $in[$i] =~ s/\+/ /g;
      # Convert %XX from hex numbers to alphanumeric
      $in[$i] =~ s/%(..)/pack("c",hex($1))/ge;
      # Split into key and value.
      $loc = index($in[$i],"=");
      $key = substr($in[$i],0,$loc);
      $val = substr($in[$i],$loc+1);
      $in{$key} .= '\0' if (defined($in{$key})); # \0 is the multiple separator
      $in{$key} .= $val;
  }
}


sub get_env_variable{
   $env_variable = $_[0]; 
   @env = `env`;
   @array=();
   push(@array,grep(/$env_variable/,@env));
   chomp($_ = $array[0]); 
   $_ = &sanitize($_);
   s/^.*=//s;
   return $_;
}


# Added per CERT advistory - send Alek EMail if you want changes here ...
sub sanitize {
   # This is opened up a bit 'cause we want to allow Perl regular expressions ...
   local ($OK_CHARS);
   $OK_CHARS='-a-zA-Z0-9_.@=/+ \,\(\)\s';
# Hack to handle comma & parens ...
   s/%2C/\,/g;
   s/%28/\(/g;
   s/%29/\)/g;
   s/[^$OK_CHARS]/_/go;
   return $_;
}


sub clear_window {
      $frame = $_[0];
      print "<script language=JavaScript>";
      print "window.open('about:blank','$frame');";
      print "</script>";
}


# This is misc. counter stuff ... better ways to do this, but this is pretty portable ...
sub Increment_Accumulator {
   local ($Accumulator,$inc) = @_; local ($accum);
   open (LOG,"<$Accumulator") || return "-111";
   chomp($accum = <LOG>);
   close (LOG);
   $accum =  $accum + $inc;
   $_ = &get_lock_file($Accumulator,5);
   if ( /Not able to/ ) {
      return "-111";
   } elsif ( /could not get lock/ ) {
      return "-222";
   } else {
      print LOCKFILE "$accum\n";
      close (LOCKFILE); 
      return $accum;
   }
}


sub Get_Accumulator {
   local ($Accumulator) =@_;local ($accum);
   open (LOG,"<$Accumulator") || die " Problem opening the accumulator file $Accumulator\n";
   chomp($accum = <LOG>);
   close (LOG);
   return $accum;
}


sub get_lock_file {
   my($lock_file,$how_long_to_wait) = @_;
   my $sleep_time = 0;
   open(LOCKFILE,">$lock_file" ) || return "Not able to open $lock_file: $!";
# Some trickery from the Perl Book to flush the buffer so other instances can read
   select((select(LOCKFILE),$| =1)[0]);
   while ( ! (flock(LOCKFILE,2|4))) {
      if (( -t STDIN) && ( -t STDOUT)) {
         if ($sleep_time % 5 == 0) {
            print "$lock_file is locked - waiting ...\n";
         }
      }
      sleep(1);
      $sleep_time++;
      if ( $sleep_time > $how_long_to_wait ) {
         close(LOCKFILE);
         return "could could not get lock";
      }
   }
   return "lock acquired";
}

1; 
